%% Procedure to access directory "dname". It keeps track of dirs
%% that are accessed. It checks that the owner directory
%% is accessed before accessing "dname" and adds "dname" to the
%% list of accessed directories.

procedure _access (dname) local (GetOwnerDir)
	if $tolower(dname) in ("zim", "$utils") or _diraccess = "STATIC"
		return
	endif

	let <1> = $trim(dname)
	if $dirpath() like '%;#<1>(%' % already accessed
		if $dirpath() like '%;#<1>(U);%'
			return	% already accessed in update mode
		endif
		%% was accessed in read mode, release and re-access
		release #<1>
		%% re-access with _access in case an owner directory has been released
		_access('#<1>')
	endif

	compute dirs where dirname = dname eval (let GetOwnerDir=OwnerDirName)
	if $membercount >= 1 and GetOwnerDir <> ""
		_access (GetOwnerDir)		% access owner dir
	endif
	access #<1> update
	let $utils._dirstring = \
			$concat($utils._dirstring, ",#<1>,") % for use by release.cmd
endprocedure
