%% tZOMDataLoad - ZOMDataload template

on BREAK
   let vZOMBreak = $true
   RETURN
endon

let <DataLoadPgmName> = '#<1>' \
    <DataLoadDocName> = $trim(vObjectDataSaveDoc) \
    <ObjectName> = $trim(vObjectName) \
    <ObjectDataSaveDir> = $trim(vObjectDirName) \
    <ObjectDirName> = $trim(vObjectDirName)
let vDC18 = '' \
    vDC1  = '0'

%%%         Look for Sequence Number fields on the Object
compute 1 Fields where OwnerName = vObjectName     \
                   and DirName   = vObjectDirName  \
                   and Reqd      = 'SEQ'           \
          eval ((let vDC18 = FieldName),(let vDC1 = $True))
if $MemberCount > 0
   let vZOMSequenceNumber = $TRUE               %%% There is a SequenceNumber Field
   let <SeqFieldName>     = $trim(vDC18)

   if vZOMOptions[ZOMSOption] = 'RENUMBER'
      let <SeqStatus> = "ON"                %%% Start over the sequence
      let <SetSeqVal> = "Set SequenceNumber #<ObjectDirName>.#<ObjectName> 1" 
   else
      let <SeqStatus>   = "OFF"               %%% Keep the sequence numbers from the document
      let <SetSeqVal>   = " "
   endif

   let <SequenceNum> = "Set SequenceNumber #<ObjectDirName>.#<ObjectName> #<SeqStatus>"

else
    let vZOMSequenceNumber = $FALSE    %%% Object has no sequence field
    let <SequenceNum> = "% "  \
        <SeqStatus>   = " "   \
        <SetSeqVal>   = "% "  \
        <SeqFieldName>= " "      
endif

<<
procedure #<DataLoadPgmName>() 

on BREAK
   let vZOMBreak = $true
   SET RESTORE
   RETURN
endon
%           Is there a previous data save?
   compute 1 #<ObjectDataSaveDir>.#<DataLoadDocName> eval ''
   if $membercount = 0                    %%% No data to load
      let vzomaction = "No data to load on #<ObjectDataSaveDir>.#<DataLoadDocName>" 
      pzomDisplay()
      SET SAVE
      SET OUT ERRTRACE APPEND
      out $concat("ZOMDATALOAD: No data to load: ", $trim(vObjectDirName), ".", $trim(vObjectName), ".")
      set RESTORE 
      return
   endif

   let _indent2 = "YES"                      %  Save existing data by default  
   let <RELOADED> = "NO"                     %  Indicates that data will not be loaded withou deleting existing data
   if vZOMType = " "                         %  Are we in QTC and there is existing data in the table?
         compute 1 #<ObjectDirName>.#<ObjectName> eval 1
         if $membercount > 0
            let _indent2 = $messagebox($concat("The table to load [",$trim(vObjectDirName),'.', \
                                       $trim(vObjectName),"] has data.\0a        Delete the existing data?"), \
                                       4,5,2,"DATALOAD PROCESS") 
         endif   
      if _indent2 = "CANCEL"
         return
      elseif _indent2 = "YES"   
        delete all #<ObjectDirName>.#<ObjectName>             %% Delete all data before loading 
      else     %%  _indent2 = "NO"
%              Warn that loading data may occur duplicated values 
         if $messagebox($concat("The table to load [",$trim(vObjectDirName),'.', \
                                    $trim(vObjectName),"] has data.\0aReloading may cause Duplicate Key errors\0a       CONTINUE?"), \
                                    2,4,2,"DATALOAD PROCESS") = "NO"
            RETURN
         else   
            let <RELOADED> = "YES"
         endif
      endif
   else
     delete all #<ObjectDirName>.#<ObjectName>             %% Delete all data before loading    
   endif

   
   SET SAVE
   set reset
   set eolntranslate $Utils.cEOLNTRANSLATE
   set membercount on
   set memberinterval 1000
>>
   if "#<SeqStatus>" <> " " 
      OUT "#<SequenceNum>"
      OUT "#<SetSeqVal>"
   endif   

set Save
set doclinelength 32000
set headings off
set out trim on
%=======================================================================================================================
<<
  add all #<ObjectDirName>.#<ObjectName> \
      from #<ObjectDataSaveDir>.#<DataLoadDocName> \
      let \
>>

%      Join the table fields with the datasave doc flds by Object Fieldnames and Datasavedoc Default inserted by pZOMMakeDataSave
find Flds         \
   where Flds.OwnerName = '#<DataLoadDocName>' \
     and Flds.DirName =   '#<ObjectDataSaveDir>' \
     and $mod(Flds.Sn,10) <> 0                     \
   -> sFldsDoc

find all sFldsDoc DataDocFlds2Fields Fields        \  
   where Fields.OwnerName = vObjectName \
     and Fields.DirName =   vObjectDirName \
     sorted by flds.SN                         \
     keep Flds                                 \  
   -> sFldsSaveDoc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
report from sFldsSaveDoc \
      pagesize 1 pagelines 1 columnspacing 0 leftmargin 9
   detail line column heading off \
      $concat('#<ObjectDirName>.#<ObjectName>.', $trim($translate(Flds.Default,'"','')), \
              ' = {#<ObjectDataSaveDir>.#<DataLoadDocName>.', $trim($translate(Flds.Default,'"','')), ' ',   \
              'where #<ObjectDataSaveDir>.#<DataLoadDocName>.',$trim(Flds.Fieldname), \
              ' <> "*" }', \
               {' \\' where $count(9) < $lastmember('sFldsSaveDoc'), ' '}) \ 
             :newline column 4:

   report footing \
      {$concat('evaluate (let vlMaxSeq = $max(#<ObjectDirName>.#<ObjectName>.#<SeqFieldName>+1))')  \
               where (vZOMSequenceNumber = $True and "#<SeqStatus>" = "OFF"), ' '} \
               :newline column 4:

endreport

%============================================================================================================
%
<<
   set save
   set membercount off
   set messages off
   pZOMObjectSaving("SAVE", vObjectName, vObjectDirName,$membercount)  
   set restore
>>
set restore
let <MaxSeq>      = ""
let <SetMaxSeq>   = ""

if "#<SeqStatus>"   = "OFF"
   out "Set SequenceNumber #<ObjectDirName>.#<ObjectName> ON"
endif

if "#<RELOADED>" = "YES" and "#<SeqStatus>" <> " " 
   out "compute #<ObjectDirName>.#<ObjectName> eval(let vZOMLongInt = $max(#<SeqFieldName>))"
   out "Set SequenceNumber #<ObjectDirName>.#<ObjectName> vZOMLongInt"
endif

<<
   SET RESTORE
endprocedure

>>
