% tZOMDataSave - GENERATES datasave document

on BREAK
   let vZOMBreak = $true
   RETURN
endon

let <DataSavePgmName> = '#<1>' \
    <DataSaveDocName> = '#<2>' \
    <ObjectName> = $trim(vObjectName) \
    <ObjectDataSaveDir> = $trim(vObjectDirName) \
    <ObjectDirName> = $trim(vObjectDirName)
    
<<
procedure #<DataSavePgmName>()

on BREAK
   let vZOMBreak = $true
   SET RESTORE
   RETURN
endon
   
   % Make sure the saving directory is there.
   if $zimos = 11 %% windows
      system $concat("!mkdir ", $DBPath, "\\zomsaving ") invisible remote
   else %% unix
      system $concat("mkdir -p ", $DBPath, "/zomsaving ") invisible remote
   endif   

   SET SAVE
   set reset
   set information off
   set headings off
   set output trim on
   set output fieldlistwidth off
   set output maskfield off
   set eolntranslate $Utils.cEOLNTRANSLATE
   set doclinelength 30000
   set columnspacing 0
   set output #<ObjectDataSaveDir>.#<DataSaveDocName>

   if $lasterrcode = 1613
      SET RESTORE
      let vZOMAction = $concat('  Cannot save data to ', $trim(vObjectDataSaveDir), '.', $trim(vObjectDataSaveDoc), '.')
      pZOMDisplay()
      return
   endif

   if vDCRecreate = $true
     set executemode zimmode
   endif

   list all #<ObjectDirName>.#<ObjectName> \
      format \
>>

%% N.B. This Find command must be executed first to value $setcount
%%       In the following set, FLDS corresponds to DSZOM fields and FIELDS to the object fields
%%          The modulus is used to get rid of the Null Indicator fields (always 19,29, 39, etc) 
%%       The sort should be identical to the MAKDSDOC.PGM
%%
%%find all Flds DataDocFlds2Fields Fields        \
%%   where Flds.OwnerName = '#<DataSaveDocName>' \
%%     and Flds.DirName = '#<ObjectDataSaveDir>' \
%%     and $mod(Flds.Sn,10) <> 0                 \
%%     sorted by flds.SN                         \
%%     keep Flds                                 \
%%   ->  sFieldsDoc
find Fields          \
   where Fields.OwnerName = '#<ObjectName>'  \
     and Fields.DirName = '#<ObjectDirName>' \
     and Fields.Virtual = 'No'               \
     sorted by fields.SN                     \
   ->  sFieldsDoc

let vZOMInt1 = $setcount

report from sFieldsDoc pagesize 1 pagelines 1 columnspacing 0 leftmargin 9
   detail line column heading off \
      $concat('{"*" where #<ObjectDirName>.#<ObjectName>.', $trim(Fields.FieldName),' is $null, " "} ', \
              '#<ObjectDirName>.#<ObjectName>.', $trim($translate(Fields.FieldName,'"','')), {' \\' where $count('') < $setcount, ''}) \
         :newline:
endreport
<<
   SET RESTORE

   let vZOMLongInt = $membercount
   pZOMObjectSaving("SAVE", vObjectName, vObjectDirName,vZOMLongInt)

   let vZOMAction = $concat($mask(vZOMInt1,'ZZZ,ZZZ,ZZZ,ZZ9'),  ' records saved from')
   pZOMDisplay()

   if vDCRecreate = $true
     set executemode sqlmode
   endif

endprocedure
>>
