%% tZOMPermBoot

localprocedure plSetTblSyntax(vlOption)
   let vlOption = $toupper(vlOption) \
       <PermSyntax> = $concat( \
          {'read ' where vlOption like '%R%', ''}, \
          {'add ' where vlOption like '%A%', ''}, \
          {'change ' where vlOption like '%C%' or vlOption like '%U%', ''}, \
          {'delete ' where vlOption like '%D%', ''})
endprocedure

localprocedure plSetFldSyntax(vlOption)
   let vlOption = $toupper(vlOption) \
       <PermSyntax> = $concat( \
          {'read ' where vlOption like '%R%', ''}, \
          {'update ' where vlOption like '%C%' or vlOption like '%U%', ''})
endprocedure

on BREAK
   let vZOMBreak = $true
   RETURN
endon

let <ObjType> = $trim(vObjectType) \
    <ObjName> = $trim(vObjectName) \
    <DirName> = $trim(vObjectDirName)

if not vZomOperationMode = "DC"
<<
   output 'Setting Permissions for #<ObjType> "#<ObjName>" in "#<DirName>"'
   
>>
endif
if vObjectType = DIROBJTYPE
<<
   %% Release the directory before changing it's permissions
   if $dirpath() like '%;#<ObjName>(U);%'
      let <DirAccessMethod> = 'Update'
      release #<ObjName>
   elseif $dirpath() like '%;#<ObjName>(R);%'
      let <DirAccessMethod> = 'Read'
      release #<ObjName>
   else
      let <DirAccessMethod> = ''
   endif
>>
endif

if vZOMOptions[ZOMOOPTION] is not $null
   if vObjectType = DIROBJTYPE
      plSetFldSyntax(vZOMOptions[ZOMOOPTION])
   else
      plSetTblSyntax(vZOMOptions[ZOMOOPTION])
   endif
<<
   permission #<ObjName> owner #<PermSyntax>
>>
endif

if vZOMOptions[ZOMGOPTION] is not $null
   if vObjectType = DIROBJTYPE
      plSetFldSyntax(vZOMOptions[ZOMGOPTION])
   else
      plSetTblSyntax(vZOMOptions[ZOMGOPTION])
   endif
<<
   permission #<ObjName> group #<PermSyntax>
>>
endif

if vZOMOptions[ZOMTOPTION] is not $null
   if vObjectType = DIROBJTYPE
      plSetFldSyntax(vZOMOptions[ZOMTOPTION])
   else
      plSetTblSyntax(vZOMOptions[ZOMTOPTION])
   endif
<<
   permission #<ObjName> other #<PermSyntax>
>>
endif

if vZOMDataSaveAble = 'Y'
   find all Flds \
      where Flds.OwnerName = '#<ObjName>' and Flds.DirName = '#<DirName>'

   while $setcount > 0
      let <FldName> = $trim(Flds.FieldName)

      if vZOMOptions[ZOMOOPTION] is not $null
         plSetFldSyntax(vZOMOptions[ZOMOOPTION])
<<
      permission #<ObjName>.#<FldName> owner #<PermSyntax>
>>
      endif

      if vZOMOptions[ZOMGOPTION] is not $null
         plSetFldSyntax(vZOMOptions[ZOMGOPTION])
<<
      permission #<ObjName>.#<FldName> group #<PermSyntax>
>>
      endif

      if vZOMOptions[ZOMTOPTION] is not $null
         plSetFldSyntax(vZOMOptions[ZOMTOPTION])
<<
      permission #<ObjName>.#<FldName> other #<PermSyntax>
>>
      endif

      let $setcount = $setcount - 1
      next
   endwhile
endif

if vObjectType = DIROBJTYPE
<<
   if '\#<DirAccessMethod>' > '' % Re-access the directory, if needed
      access #<ObjName> \#<DirAccessMethod>
   endif
>>
endif
