%%%           Importing tool to migrate Zim 7.x to version Zim 8.x
%%%          ====================================================
%%%                             ZIM8CNV2
%%%  Created:  by Livio Taufer @ ZIM Corporation on October 16, 2017
%%%  UPDATES:  Moved Settings to the very beggining                     %%%   Livio 26-Oct-17
%%%            Zomreset and create at the end of the execution.         %%%   Livio 31-Oct-17
%%%            Zomtouch all objects to makesure all properties are set  %%%   Livio 10-Nov-17
%%%            If still there are uncreated objects try to create them  %%%   Livio 10-Nov-17
%%%            Included a Welcome message in the end of the process     %%%   Livio 05-Dec-17
%%%            Moved the check the number of existing directories to CNV1%%%   Livio 05-Feb-18
%%%====================================================================================================
clear
set out errtrace
set out terminal
set save
set information off
let <UseExistingFileNum> = $TRUE          %%% Uses the same file number as in version 7

%%%%         SET EXECUTEMODE ZIMMODE    %%%16-Oct-17 2:32 PM
zomenable
%%%         vDPSBreak identifica se dve ser executado ou no um BYE ao final da execu'cao
if $toupper("#<1>") = "NO"
   let vDPSBreak = $FALSE
else
   let vDPSBreak = $TRUE
endif

%%       Create the document TabControlDoc to allow the use of old Tabbed forms
if $exist$( 'ZIM', 'TabControlDoc', 9 ) = $FALSE
   add 1 Docs \
       let \
           Docs.DocName = 'TabControlDoc'   \
           Docs.FileName = './port/tabctrl.cma'  \
           Docs.DocType = 'DATA'  \
           Docs.DirName = 'ZIM'     \
       -> $$$sDoc$$$
   zomcreate  TabControlDoc
endif

output $center($tochar("Importing tool to convert ZIMxx databases to ZIM8.",80))
output $center($tochar("==================================================",80))
output $center($tochar($concat("Database name: ",$trim($dbname)," -- DB Path: ",$trim($dbPath)),80))
output


out 'ZOM Importing Objects'
let vGeneralTrace = "2"       %%%   Display the creating object message on terminal
zomimport
let vGeneralTrace = Null

set reset


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 1) Importing Other Zim Objects
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set save
set nullvalue '$null'
set input format commadelimited
Set doclinelength 32000
set delimiter ':'
set textdelimiter '^'
set memberinterval 1000


out 'Adding _Reports from _ReportDoc'
add _Reports from _ReportDoc

out 'Adding _RepColumns from _RepColumnDoc'
add _RepColumns from _RepColumnDoc

out 'Adding _QSortFormat from _QSortFormatDoc'
add _QSortFormat from _QSortFormatDoc

out 'Adding _QSelect from _QSelectDoc'
add _QSelect from _QSelectDoc

out 'Adding _Components from _ComponentsDoc'
add _Components from _ComponentDoc

out 'Adding ObjectAction from ObjectActionDoc'
delete all ObjectAction
add ObjectAction from ObjectActionDoc

out 'Adding EventAction from EventActionDoc'
delete all EventAction
add EventAction from EventActionDoc

out 'Adding ApplMessages from ApplMessageDoc'
delete all ApplMessages
add ApplMessages from ApplMessageDoc

out 'Adding ApplMessTitles from ApplMessTitleDoc'
delete all ApplMessTitles
add ApplMessTitles from ApplMessTitleDoc

out 'Adding RemoteProcedures from RemoteProcDoc'
add RemoteProcedures from RemoteProcDoc

out 'Adding ResultSets from ResultSetDoc'
add ResultSets from ResultSetDoc

out 'Adding ResultFields from ResultFieldDoc'
add ResultFields from ResultFieldDoc
%        Tabcontrol cannot be automatically converted
out 'Adding TabControl from TabControlDoc'
add TabControl from TabControlDoc

%%%         Lets make sure all objects have the correct settings in Objectlist
zomtouch *
%%%         If there are uncreated objects - create them.
find objlist where NotExist = 'Y'
let vZOMint1 = $setcount
if $setcount > 0
   out "   Creating" $tochar($setcount,5) " uncreated objects."
   let $page = 0
   let vZomDisplay = "N"
   set errors off
   while (let $page = $page + 1) <=3
      out "      Creating Pass" $tochar($page,2)
      zomcreate +PE!
      find objlist where NotExist = 'Y'
      if $setcount = 0 or $setcount  vZOMint1
         break
      endif
   endwhile
   set errors on
   let vZomDisplay = "S"
endif
find objlist where NotExist = 'Y'
if $setcount > 0
   out $tochar($setcount,5) " Uncreated objects - Please verify."
else
   out "   ZIM8CNV2 DONE!"
endif
zomDELETE TabControlDoc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Done!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if vDPSBreak = $TRUE
   bye
endif
set reset

out $center($tochar("WELCOME TO ZIM8.50",80))
out $center($tochar("YOUR DATABASE IS READY TO USE. ENJOY ALL NEW FEATURES",80))
out $center($tochar("=====================================================",80))
sleep 5
return
%% End of File %%
