/*
 *
 *		UNIX/XENIX Example of a C Program to Handle a $USERFUNCTION
 *		call from ZIM.  Refer to the include file "zfunc.h" for
 *		an explanation of the different data types that ZIM
 *		makes use of.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#define UNIXV
#include "zfunc.h"
#include <errno.h>
#include <sys/types.h>
#include <linux/ipc.h>
#endif
#include <sys/msg.h>

#define	INMSG	1L
#define	OUTMSG	2L
extern	char	*malloc ();

	int
main (int argc, char **argv)
{
	short		i;
	struct	msgbuf *pMsgBuf;
    tUserBuf	*pUB;
	char		*pC;
	char		*pData;
	short		len;
	short		ResType;
	int			MsgQID;
	int			MsgStatus;

	/*
	 *	First time called, allocate a buffer for the largest
	 *	message we expect to receive.
	 *
	 */

fprintf (stderr, "MsgQID is %s.\n", argv[1]);

	MsgQID = atoi (argv[1]);

	if ((pMsgBuf = (struct msgbuf *) malloc (1024)) == NULL)
	{ 	fprintf (stderr, "ZIMFUNC, Initialisation failure.\n");
		exit (999);
	}

	/*
	 *	Now sit in a loop waiting for messages.
	 *
	 */

	for (;;)
	{	if ((MsgStatus = msgrcv (MsgQID, pMsgBuf, 1024, INMSG, MSG_NOERROR)) < 0)
		{	if (MsgStatus == -1 && errno == EIDRM)
				break;
			fprintf (stderr, "ZIMFUNC: Receive failed, RC=%d.\n", errno);
			continue;
		}

	/*
	 *
	 *	What we do with the message is entirely up to us. We can not
	 *	alter the type, but we can set the length of argument 1
	 *  (the result) to UBResLen - the maximum size of the result.
	 *	We may also set the null flag.
	 *
	 */

		pUB = (tUserBuf *) pMsgBuf;
		pC = (char *)pUB + sizeof(tUserBuf) + pUB->UBNArgs * sizeof(tInfVal);
		fprintf (stderr, "ZIMFUNC: No. of args %d.\n", pUB->UBNArgs);
		fprintf (stderr, "ZIMFUNC: Max. len of the result %d.\n", pUB->UBResLen);

		for (i = 0; i < pUB->UBNArgs; i++)
		{	pData = pC + pUB->UBInfVal[i+1].uval.CCDisp;
			len = pUB->UBInfVal[i+1].vlen;

			fprintf (stderr, "ZIMFUNC: Arg %d,  type %d, len %d, value %.*s.\n",
					  i+1, pUB->UBInfVal[i+1].InfType, len, len, pData);
		}

	/*
	 *
	 *	If the length of arg 1 is at least 2 less than the max, surround it
	 *	with "" just to show how we can update the result.
	 *
	 *	Reply to the caller with original message with
	 *	Num args, array of Information Values, and first argument.
	 *
	 */

		len = pUB->UBInfVal[1].vlen;

		if ((pUB->UBInfVal[1].InfType & CCTYPES) == CCCHAR
				&& len + 2 <= pUB->UBResLen)	/* is there room for quotes */
		{
			memcpy (pC + 1, pC + pUB->UBInfVal[1].uval.CCDisp, len);	/* shift right the data */
			*pC = '"';
			*(pC + len + 1) = '"';
			len += 2;
		}
		else
			memcpy (pC, pC + pUB->UBInfVal[1].uval.CCDisp, len);

		pUB->UBInfVal[0].vlen = len;
		pUB->UBInfVal[0].decimals = pUB->UBInfVal[1].decimals;
		pUB->UBMsgType = OUTMSG;

		msgsnd (MsgQID, pMsgBuf,
sizeof(tUserBuf) + pUB->UBNArgs * sizeof(tInfVal) + len, IPC_NOWAIT);
	}

	return;
}

