USE [BOU_SQL_ATIVA] 
GO
/****** Object:  UserDefinedFunction [dbo].[_ISALPHABETIC]    Script Date: 06/04/2013 15:43:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISALPHABETIC] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type in ('datetime','numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 0
    else
   if @type in ('char','varchar','text')
      BEGIN
         DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(vARCHAR(8000),@VALUE)
        set @result= CASE When PATINDEX('%[^a-z]%',@STRING)= 0 THEN 1 ELSE 0 END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_ISALPHANUMERIC]    Script Date: 06/04/2013 15:43:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISALPHANUMERIC] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type in ('datetime','numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 0
    else
   if @type in ('char','varchar','text')
      BEGIN
         DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(vARCHAR(8000),@VALUE)
        set @result= CASE When PATINDEX('%[^a-zA-Z0-9]%',@STRING)= 0 THEN 1 ELSE 0 END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_ISDIGIT]    Script Date: 06/04/2013 15:43:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISDIGIT] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type in ('datetime','numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 0
    else
   if @type in ('char','varchar','text')
      BEGIN
        DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(varchar(8000),@VALUE)
        set @result= CASE When PATINDEX('%[^0-9]%',@STRING)= 0 THEN 1 ELSE 0 END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_ISLOWER]    Script Date: 06/04/2013 15:43:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISLOWER] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type in ('datetime','numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 0
    else
   if @type in ('char','varchar','text')
      BEGIN
         DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(vARCHAR(8000),@VALUE)
        set @result= CASE When PATINDEX('%[ABCDEFGHIJKLMNOPQRSTUVWXYZ]%',@string  COLLATE Latin1_General_CS_AI) > 0 
                  THEN 0
                  ELSE 1
                  END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_ISNUMBER]    Script Date: 06/04/2013 15:43:38 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISNUMBER] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type = 'datetime'
       set @result = 0
   else
   if @type in ('numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 1
    else
   if @type in ('char','varchar','text')
      BEGIN
        DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(varchar(8000),@VALUE)
        set @result= CASE When PATINDEX('%[^.0123456789]%',@STRING)= 0 THEN 1 ELSE 0 END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_ISUPPER]    Script Date: 06/04/2013 15:43:38 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_ISUPPER] 
(
   @VALUE sql_variant
)
RETURNS INT
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as int
   set @result = NULL
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type in ('datetime','numeric','decimal','int','float','real','bigint','money','smallmoney')
       set @result = 0
    else
   if @type in ('char','varchar','text')
      BEGIN
         DECLARE @STRING VARCHAR(8000)
        set @STRING = CONVERT(vARCHAR(8000),@VALUE)
        set @result= CASE When PATINDEX('%[abcdefghijklmnopqrstuvwxyz]%',@string  COLLATE Latin1_General_CS_AI) > 0 
                  THEN 0
                  ELSE 1
                  END
      END
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_MASK]    Script Date: 06/04/2013 15:43:38 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[_MASK] 
(
   @VALUE sql_variant,  
   @MASK varchar(128)
)
RETURNS varchar(128)
WITH SCHEMABINDING
AS
BEGIN
   DECLARE @Result varchar(128)
   DECLARE @type varchar(128)
   declare @mask_length int
   declare @i int
   declare @j int
   set @mask_length=len(@MASK)
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type = 'datetime'
      set @result = dbo.mask_date(cast(@VALUE as datetime), @MASK)
   else
   if @type = 'char' or @type = 'varchar' 
      set @result = dbo.mask_str(cast(@VALUE as varchar(512)), @MASK)
   else
   if @type = 'numeric' or @type = 'decimal' or @type = 'int' or @type = 'float' or @type = 'real' or @type = 'bigint' or @type = 'money' or @type = 'smallmoney'
      set @result = dbo.mask_num2(cast(@VALUE as numeric(32, 16)), @MASK)
   else
      set @result = 'dbo._mask: ' + @type + ': invalid type' 
   RETURN @Result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_MAXOF]    Script Date: 06/04/2013 15:43:38 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_MAXOF] 
(
   @VALUE1  sql_variant,
   @VALUE2  sql_variant
)
RETURNS Numeric (32,16)
AS
BEGIN
   if dbo._ISNUMBER(@VALUE1) = 1 AND dbo._ISNUMBER(@VALUE2) = 1 
      BEGIN
         DECLARE @result Numeric (32,16)
         DECLARE @Val1   Numeric (32,16)
         DECLARE @Val2   Numeric (32,16)
         set @result = NULL
         set @Val1 = convert(Numeric(32,16),@VALUE1)
         set @Val2 = convert(Numeric(32,16),@VALUE2)
         
         if @VAL1 > @VAL2 
            set @result = @Val1
         else
            set @result = @Val2
      END
   ELSE
     set @result = NULL
   return @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_MINOF]    Script Date: 06/04/2013 15:43:38 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_MINOF] 
(
   @VALUE1  sql_variant,
   @VALUE2  sql_variant
)
RETURNS Numeric (32,16)
AS
BEGIN
   if dbo._ISNUMBER(@VALUE1) = 1 AND dbo._ISNUMBER(@VALUE2) = 1 
      BEGIN
         DECLARE @result Numeric (32,16)
         DECLARE @Val1   Numeric (32,16)
         DECLARE @Val2   Numeric (32,16)
         set @result = NULL
         set @Val1 = convert(Numeric(32,16),@VALUE1)
         set @Val2 = convert(Numeric(32,16),@VALUE2)
         
         if @VAL1 > @VAL2 
            set @result = @Val2
         else
            set @result = @Val1
      END
   ELSE
     set @result = NULL
   return @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_TOCHAR]    Script Date: 06/04/2013 15:43:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[_TOCHAR] 
(
   @VALUE sql_variant,
   @Scale Int
)
RETURNS Varchar (max)
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as VarChar(max)
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)

   if @type = 'datetime'
         SET @result = CONVERT(VARCHAR(8), @VALUE, 112)
   else
   if @type = 'char' or @type = 'varchar'
         SET @result = LEFT(CONVERT(VARCHAR(8), @VALUE),@Scale)
   else
   if @type = 'numeric' or @type = 'decimal' or @type = 'int' or @type = 'float' or @type = 'real' or @type = 'bigint' or @type = 'money' or @type = 'smallmoney'
         SET @result = LEFT(CAST(@VALUE AS VARCHAR(MAX)),@Scale)
   else
      set @result = NULL 

   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_TONUM]    Script Date: 06/04/2013 15:43:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_TONUM] 
(
   @VALUE sql_variant,
    @Scale Int
)
RETURNS Numeric(32,16)
AS
BEGIN
   DECLARE @type varchar(128)
   DECLARE @result as Numeric(32,16)
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type = 'datetime'
      begin
            declare @x AS CHAR(8)
         SET @x = CONVERT(CHAR(8), @VALUE, 112)
         if ISDATE(@x)= 1
            set @result = cast(@x as int)
         else
            set @result = 0
        end
   else
   if @type = 'char' or @type = 'varchar'
      BEGIN
         set @x= cast(@VALUE as VARCHAR(max))
         if ISNUMERIC(@x) = 1
            set @result = ROUND(((cast(@VALUE as Numeric(32,16)) * power(10,@Scale))/power(10,@Scale)),@Scale)
         else
            set @result = 0   
      END
   else
   if @type = 'numeric' or @type = 'decimal' or @type = 'int' or @type = 'float' or @type = 'real' or @type = 'bigint' or @type = 'money' or @type = 'smallmoney'
      set @result = ROUND(((cast(@VALUE as Numeric(32,16)) * power(10,@Scale))/power(10,@Scale)),@Scale)
   else
      set @result = 0 
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[_TRUNC]    Script Date: 06/04/2013 15:43:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[_TRUNC] 
(
   @VALUE sql_variant   
)
RETURNS bigint
AS
BEGIN
   DECLARE @type varchar(128)
   declare @result as bigint
   set @type = cast(SQL_VARIANT_PROPERTY (@VALUE, 'BaseType') as varchar)
   if @type = 'datetime'
      begin
         declare @x AS CHAR(8)
         SET @X = CONVERT(CHAR(8), @VALUE, 112)
         set @result = cast(@x as int)
        end
   else
   if @type = 'char' or @type = 'varchar'
      if @VALUE = ' '
         set @result = 0
      else
          set @result = floor(cast(@VALUE as decimal(32, 16)))
   else
   if @type = 'numeric' or @type = 'decimal' or @type = 'int' or @type = 'float' or @type = 'real' or @type = 'bigint' or @type = 'money' or @type = 'smallmoney'
      set @result = floor(cast(@VALUE as decimal(32, 16)))
   else
      set @result = 0 
   RETURN @result
END

GO
/****** Object:  UserDefinedFunction [dbo].[LPad]    Script Date: 06/04/2013 15:43:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/*
 ==========================================================
 Author:Md. Humayun Rashed: rashed_2k3@yahoo.co.in
 Create date: 15/03/2012
 Description:This function work for Left padding. there are 3 parameters. the first parameter 
			is for which value you want to padding, 
			2nd parameter is how many length for padding and 3rd parameter is 
			which value will used to pad 
 ==========================================================
*/
CREATE function [dbo].[LPad]
(
	@pad_value varchar(500),
	@pad_length int,
	@pad_with varchar(10)
)
returns varchar(5000)
as
BEGIN
	Declare @value_result varchar(5000)
	select @value_result= replace(str(@pad_value,@pad_length),' ',@pad_with) 
	return @value_result
END
GO
/****** Object:  UserDefinedFunction [dbo].[MASK_DATE]    Script Date: 06/04/2013 15:43:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[MASK_DATE] 
(
   @VALUE datetime,  
    @MASK varchar(128)
)
RETURNS varchar(128)
WITH SCHEMABINDING
AS
BEGIN
   DECLARE @Result varchar(128)
    declare @mask_length int
    declare @day as char(2)
   declare @month as char(2)
    declare @year as char(8)
   declare @i int
    set @mask_length=len(@MASK)
   set @i = day(@value)
   set @day = replace(str(@i, 2), ' ', '0')
   set @i = month(@value)
   set @month = replace(str(@i, 2), ' ', '0')
   set @i = year(@value)
   set @year = replace(str(@i, 4), ' ', '0')
    set @result = replace(lower(@MASK), 'dd', @day)
    set @result = replace(@result, 'mm', @month)
    set @result = replace(@result, 'yyyy', @year)
   set @result = replace(@result, 'yy', substring(@year, 3, 2))
   RETURN @Result
END

GO
/****** Object:  UserDefinedFunction [dbo].[MASK_NUM]    Script Date: 06/04/2013 15:43:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[MASK_NUM] 
(
   @VALUE numeric(32,16),
   @MASK varchar(128)
)
RETURNS varchar(128)
WITH SCHEMABINDING
AS
BEGIN
   DECLARE @Result varchar(128)
   declare @mask_length int
   declare @i int
   declare @j int

   set @mask_length=len(@MASK)
   declare @qtddec int
   declare @valor numeric(32, 16)
   set @i = charindex('.', @MASK)
   if (@i=0)
      begin
      set @qtddec = 0
      set @i = charindex(',', @MASK)
      end
    else
      begin
      set @qtddec = @mask_length - @i
      end
   if (@i=0)
      begin
      set @valor = cast(@value as numeric(20, 0))
      set @Result = replace(str(@valor, @mask_length, 0), ' ', '0')
      end
   else
      begin
      declare @valor_str varchar(60)
      declare @m as char(1)
      declare @v as char(1)
      declare @have_minus bit
      declare @error bit
      set @result = ''
      set @valor = cast(@value as numeric(32, 16))
      set @valor_str = str(@valor, @mask_length, @qtddec)
      set @i = @mask_length
      set @j = len(@valor_str)
      if charindex('-', @MASK) > 0 set @have_minus = 1 else set @have_minus = 0
      --set @result=@valor_str + ' i:' + str(@i, 5, 0) + ' j:' + str(@j, 5, 0) + ' dec: ' + str(@qtddec, 5, 0)
      if charindex('*', @valor_str) <> 0 or
         (charindex(',', @MASK) <> 0 and charindex('.', @valor_str) = 0)
         begin
         set @error = 1
         set @i = 0
         end
      while (@i>0)
         begin
         set @m = substring(@MASK, @i, 1)
         set @v = substring(@valor_str, @j, 1)
         set @i = @i - 1
         if @v = '-'
            begin
            if @have_minus = 1
               begin
               set @result = @v + @result
               set @j = @j - 1 
               end
            else
               begin
               set @j = @j - 1
               end
            end
         else 
         if @m = '.'
            begin
            if @v = '.'
               begin
               set @result = ',' + @result
               set @j = @j - 1 
               end
            else
               set @error = 1
            end
         else 
         if @m = ',' 
            begin
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = '.' + @result
            end
         else 
         if @m = '9'
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = '0' + @result
            else
               set @result = @v + @result
            end
         else 
         if lower(@m) = 'z' 
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = @v + @result
            end
         else 
         if @m = '-' 
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = @v + @result
            end
         else 
            begin
            set @j = @j - 1
            set @result = @m + @result
            end
         end
      if @valor < 0 and charindex('-', @result) = 0 and @have_minus = 1
         set @error = 1
      if @error = 1
         set @result = replicate('*', @mask_length)
      end
   RETURN @Result
END

GO
/****** Object:  UserDefinedFunction [dbo].[MASK_NUM2]    Script Date: 06/04/2013 15:43:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[MASK_NUM2] 
(
   @VALUE numeric(32,16),
   @MASK varchar(128)
)
RETURNS varchar(128)
WITH SCHEMABINDING
AS
BEGIN
    --
   -- 28jun11 17:48 Valter
   -- Baseado em MASK_NUM com alteraes para correo de BUGs
   --
   DECLARE @Result varchar(128)
   declare @mask_length int
   declare @i int
   declare @j int

   set @mask_length=len(@MASK)
   declare @qtddec int
   declare @valor numeric(32, 16)
   set @i = charindex('.', @MASK)
   if (@i=0)
      begin
      set @qtddec = 0
      set @i = charindex(',', @MASK)
      end
   else
      begin
      set @qtddec = @mask_length - @i
      end
   begin
   declare @valor_str varchar(60)
   declare @m as char(1)
   declare @v as char(1)
   declare @have_minus bit
   declare @error bit
   set @result = ''
   set @valor = cast(@value as numeric(32, 16))
   set @valor_str = str(@valor, @mask_length, @qtddec)
   if charindex('*', @valor_str) <> 0
      begin
      set @result = replicate('*', @mask_length)
      return @result
      end
   if charindex('-', @MASK) > 0 set @have_minus = 1 else set @have_minus = 0
   set @i = @mask_length
   set @j = len(@valor_str)
   --set @result=@valor_str + ' i:' + str(@i, 5, 0) + ' j:' + str(@j, 5, 0) + ' dec: ' + str(@qtddec, 5, 0)
   --return @result
   while (@i>0)
      begin
      set @m = substring(@MASK, @i, 1)
      set @v = substring(@valor_str, @j, 1)
      set @i = @i - 1
      if @v = '-'
         begin
         if @have_minus = 1
            begin
            set @result = @v + @result
            set @j = @j - 1 
            end
         else
            begin
            set @j = @j - 1
            end
            end
      else 
         if @m = '.'
            begin
            if @v = '.'
               begin
               set @result = ',' + @result
               set @j = @j - 1 
               end
            else
               set @error = 1
            end
         else 
         if @m = ',' 
            begin
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = '.' + @result
            end
         else 
         if @m = '9'
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = '0' + @result
            else
               set @result = @v + @result
            end
         else 
         if lower(@m) = 'z' 
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = @v + @result
            end
         else 
         if @m = '-' 
            begin
            set @j = @j - 1
            if @v = ' '
               set @result = ' ' + @result
            else
               set @result = @v + @result
            end
         else 
            begin
            set @j = @j - 1
            set @result = @m + @result
            end
         end
      if @valor < 0 and charindex('-', @result) = 0 and @have_minus = 1
         set @error = 1
      if @error = 1
         set @result = replicate('*', @mask_length)
         return @result
      end
      if @j > 1
         begin
         set @result = '*?*' 
         return @result
      end
   RETURN @Result
END

GO
/****** Object:  UserDefinedFunction [dbo].[MASK_STR]    Script Date: 06/04/2013 15:43:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[MASK_STR] 
(
   -- Add the parameters for the function here
   @VALUE varchar(512), 
   @MASK varchar(512)
)
RETURNS varchar(128)
WITH SCHEMABINDING
AS
BEGIN
   DECLARE @Result varchar(512)
   declare @mask_length int
   declare @i int
   declare @j int
   set @mask_length=len(@MASK)
   set @Result = ''
   set @i = 1
   set @j = 1
   while (@i<=@mask_length)
      begin
      if substring(@MASK, @i, 1) = '?'
         begin
         set @result = @result + substring(@VALUE, @j, 1)
         set @j = @j + 1
         end
      else
         begin
         set @result = @result + substring(@MASK, @i, 1)
         end
      set @i= @i + 1
      end
   RETURN @Result
END

GO
/****** Object:  UserDefinedFunction [dbo].[RPad]    Script Date: 06/04/2013 15:43:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/*
 ==========================================================
 Author:		Md. Humayun Rashed: rashed_2k3@yahoo.co.in
 Create date:	15/03/2012
 Description:	This function work for Right padding. there are 3 parameters. the first parameter is 
				for which value you want to padding, 
				2nd parameter is how many length for padding and 3rd parameter 
				is which value will used to pad 
 ==========================================================
*/
CREATE function [dbo].[RPad]
(
	@pad_value varchar(500),
	@pad_length int,
	@pad_with varchar(10)
)
returns varchar(5000)
as
BEGIN
	Declare @valueResult varchar(5000)
	select @valueResult=@pad_value+replace(replace(str(@pad_value,@pad_length),' ',@pad_with),@pad_value,'')
	return @valueResult
END
GO
/****** Object:  UserDefinedFunction [dbo].[TRIM]    Script Date: 06/04/2013 15:43:41 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[TRIM](@string VARCHAR(MAX))
RETURNS VARCHAR(MAX)
BEGIN
RETURN LTRIM(RTRIM(@string))
END

GO
/****** Object:  UserDefinedFunction [dbo].[ZTRIM]    Script Date: 06/04/2013 15:43:41 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[ZTRIM](@VALUE VARCHAR(MAX))
   RETURNS VARCHAR(MAX)
BEGIN
   RETURN @VALUE;
END;
